/* BluetoothClient.c generated by valac 0.56.17, the Vala compiler
 * generated from BluetoothClient.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright © 2015-2022 Budgie Desktop Developers
 * Copyright (C) 2015 Alberts Muktupāvels
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Inspired by gnome-bluetooth and Elementary.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <upower.h>
#include "statusapplet.h"

#define BLUEZ_DBUS_NAME "org.bluez"
#define BLUEZ_MANAGER_PATH "/"
#define BLUEZ_ADAPTER_INTERFACE "org.bluez.Adapter1"
#define BLUEZ_DEVICE_INTERFACE "org.bluez.Device1"
#define BLUETOOTH_ADDRESS_PREFIX "/org/bluez/"
#define RFKILL_DBUS_NAME "org.gnome.SettingsDaemon.Rfkill"
#define RFKILL_DBUS_PATH "/org/gnome/SettingsDaemon/Rfkill"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_BLUETOOTH_CLIENT (bluetooth_client_get_type ())
#define BLUETOOTH_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BLUETOOTH_CLIENT, BluetoothClient))
#define BLUETOOTH_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BLUETOOTH_CLIENT, BluetoothClientClass))
#define IS_BLUETOOTH_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BLUETOOTH_CLIENT))
#define IS_BLUETOOTH_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BLUETOOTH_CLIENT))
#define BLUETOOTH_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BLUETOOTH_CLIENT, BluetoothClientClass))

typedef struct _BluetoothClient BluetoothClient;
typedef struct _BluetoothClientClass BluetoothClientClass;
typedef struct _BluetoothClientPrivate BluetoothClientPrivate;
enum  {
	BLUETOOTH_CLIENT_0_PROPERTY,
	BLUETOOTH_CLIENT_HAS_ADAPTER_PROPERTY,
	BLUETOOTH_CLIENT_RETRIEVE_FINISHED_PROPERTY,
	BLUETOOTH_CLIENT_NUM_PROPERTIES
};
static GParamSpec* bluetooth_client_properties[BLUETOOTH_CLIENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothClientCreateUpowerClientData BluetoothClientCreateUpowerClientData;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
typedef struct _BluetoothClientCreateObjectManagerData BluetoothClientCreateObjectManagerData;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
enum  {
	BLUETOOTH_CLIENT_DEVICE_ADDED_SIGNAL,
	BLUETOOTH_CLIENT_DEVICE_REMOVED_SIGNAL,
	BLUETOOTH_CLIENT_UPOWER_DEVICE_ADDED_SIGNAL,
	BLUETOOTH_CLIENT_UPOWER_DEVICE_REMOVED_SIGNAL,
	BLUETOOTH_CLIENT_AIRPLANE_MODE_CHANGED_SIGNAL,
	BLUETOOTH_CLIENT_NUM_SIGNALS
};
static guint bluetooth_client_signals[BLUETOOTH_CLIENT_NUM_SIGNALS] = {0};

struct _BluetoothClient {
	GObject parent_instance;
	BluetoothClientPrivate * priv;
};

struct _BluetoothClientClass {
	GObjectClass parent_class;
};

struct _BluetoothClientPrivate {
	GCancellable* cancellable;
	GDBusObjectManagerClient* object_manager;
	UpClient* upower_client;
	Rfkill* rfkill;
	gboolean _has_adapter;
	gboolean _retrieve_finished;
};

struct _BluetoothClientCreateUpowerClientData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothClient* self;
	UpClient* _tmp0_;
	GCancellable* _tmp1_;
	UpClient* _tmp2_;
	UpClient* _tmp3_;
	UpClient* _tmp4_;
	UpClient* _tmp5_;
	GError* e;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GError* _inner_error0_;
};

struct _Block4Data {
	int _ref_count_;
	BluetoothClient* self;
	GDBusObject* object;
};

struct _Block5Data {
	int _ref_count_;
	BluetoothClient* self;
	GDBusObject* object;
};

struct _Block6Data {
	int _ref_count_;
	BluetoothClient* self;
	GDBusObject* object;
};

struct _BluetoothClientCreateObjectManagerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothClient* self;
	GDBusObjectManagerClient* _tmp0_;
	GCancellable* _tmp1_;
	GDBusObjectManagerClient* _tmp2_;
	GDBusObjectManagerClient* _tmp3_;
	GDBusObjectManagerClient* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GDBusObjectManagerClient* _tmp7_;
	GDBusObjectManagerClient* _tmp8_;
	GDBusObjectManagerClient* _tmp9_;
	GDBusObjectManagerClient* _tmp10_;
	GError* e;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _Block7Data {
	int _ref_count_;
	BluetoothClient* self;
	GList* adapters;
};

static gint BluetoothClient_private_offset;
static gpointer bluetooth_client_parent_class = NULL;
static GType bluetooth_client_type_id = 0;

GType bluetooth_client_register_type (GTypeModule * module);
VALA_EXTERN GType bluetooth_client_get_type (void) G_GNUC_CONST ;
GType adapter1_proxy_get_type (void);
GType device1_proxy_get_type (void);
static GType bluetooth_client_get_proxy_type_func (BluetoothClient* self,
                                            GDBusObjectManagerClient* manager,
                                            const gchar* object_path,
                                            const gchar* interface_name);
static void bluetooth_client_create_upower_client_data_free (gpointer _data);
static void bluetooth_client_create_upower_client (BluetoothClient* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static void bluetooth_client_create_upower_client_finish (BluetoothClient* self,
                                                   GAsyncResult* _res_);
static gboolean bluetooth_client_create_upower_client_co (BluetoothClientCreateUpowerClientData* _data_);
static void bluetooth_client_create_upower_client_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void bluetooth_client_upower_device_added_cb (BluetoothClient* self,
                                              UpDevice* up_device);
static void _bluetooth_client_upower_device_added_cb_up__client_device_added (UpClient* _sender,
                                                                       UpDevice* device,
                                                                       gpointer self);
static void bluetooth_client_upower_device_removed_cb (BluetoothClient* self,
                                                const gchar* object_path);
static void _bluetooth_client_upower_device_removed_cb_up__client_device_removed (UpClient* _sender,
                                                                           const gchar* object_path,
                                                                           gpointer self);
static void bluetooth_client_coldplug_client (BluetoothClient* self);
static void bluetooth_client_create_object_manager_data_free (gpointer _data);
static void bluetooth_client_create_object_manager (BluetoothClient* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
static void bluetooth_client_create_object_manager_finish (BluetoothClient* self,
                                                    GAsyncResult* _res_);
static gboolean bluetooth_client_create_object_manager_co (BluetoothClientCreateObjectManagerData* _data_);
static GType _bluetooth_client_get_proxy_type_func_gd_bus_proxy_type_func (GDBusObjectManagerClient* manager,
                                                                    const gchar* object_path,
                                                                    const gchar* interface_name,
                                                                    gpointer self);
static void bluetooth_client_create_object_manager_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
static void ___lambda4_ (BluetoothClient* self,
                  GDBusObject* object);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda5_ (Block4Data* _data4_,
                 GDBusInterface* iface);
static void bluetooth_client_on_interface_added (BluetoothClient* self,
                                          GDBusObject* object,
                                          GDBusInterface* iface);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void ____lambda4__gfunc (gconstpointer data,
                         gpointer self);
static void _bluetooth_client_on_interface_added_g_dbus_object_manager_interface_added (GDBusObjectManager* _sender,
                                                                                 GDBusObject* object,
                                                                                 GDBusInterface* interface_,
                                                                                 gpointer self);
static void bluetooth_client_on_interface_removed (BluetoothClient* self,
                                            GDBusObject* object,
                                            GDBusInterface* iface);
static void _bluetooth_client_on_interface_removed_g_dbus_object_manager_interface_removed (GDBusObjectManager* _sender,
                                                                                     GDBusObject* object,
                                                                                     GDBusInterface* interface_,
                                                                                     gpointer self);
static void ___lambda7_ (BluetoothClient* self,
                  GDBusObject* object);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda8_ (Block5Data* _data5_,
                 GDBusInterface* iface);
static void ___lambda8__gfunc (gconstpointer data,
                        gpointer self);
static void ____lambda7__g_dbus_object_manager_object_added (GDBusObjectManager* _sender,
                                                      GDBusObject* object,
                                                      gpointer self);
static void ___lambda9_ (BluetoothClient* self,
                  GDBusObject* object);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda10_ (Block6Data* _data6_,
                  GDBusInterface* iface);
static void ___lambda10__gfunc (gconstpointer data,
                         gpointer self);
static void ____lambda9__g_dbus_object_manager_object_removed (GDBusObjectManager* _sender,
                                                        GDBusObject* object,
                                                        gpointer self);
static void bluetooth_client_set_retrieve_finished (BluetoothClient* self,
                                             gboolean value);
static void bluetooth_client_create_rfkill_proxy (BluetoothClient* self);
static void ___lambda11_ (BluetoothClient* self,
                   GVariant* changed,
                   gchar** invalid);
static void ____lambda11__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                      GVariant* changed_properties,
                                                      gchar** invalidated_properties,
                                                      gpointer self);
static void bluetooth_client_set_has_adapter (BluetoothClient* self,
                                       gboolean value);
static GList* bluetooth_client_get_adapters (BluetoothClient* self);
static gboolean bluetooth_client_is_valid_address (BluetoothClient* self,
                                            const gchar* address);
static void bluetooth_client_upower_get_devices_cb (BluetoothClient* self,
                                             GObject* obj,
                                             GAsyncResult* res);
static void _bluetooth_client_upower_get_devices_cb_gasync_ready_callback (GObject* source_object,
                                                                    GAsyncResult* res,
                                                                    gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda6_ (Block7Data* _data7_,
                 GDBusObject* object);
static void ___lambda6__gfunc (gconstpointer data,
                        gpointer self);
VALA_EXTERN gboolean bluetooth_client_airplane_mode_enabled (BluetoothClient* self);
VALA_EXTERN void bluetooth_client_set_airplane_mode (BluetoothClient* self,
                                         gboolean enabled);
VALA_EXTERN BluetoothClient* bluetooth_client_new (void);
VALA_EXTERN BluetoothClient* bluetooth_client_construct (GType object_type);
VALA_EXTERN gboolean bluetooth_client_get_has_adapter (BluetoothClient* self);
VALA_EXTERN gboolean bluetooth_client_get_retrieve_finished (BluetoothClient* self);
static GObject * bluetooth_client_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void bluetooth_client_finalize (GObject * obj);
static void _vala_bluetooth_client_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_bluetooth_client_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
bluetooth_client_get_instance_private (BluetoothClient* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothClient_private_offset);
}

static GType
bluetooth_client_get_proxy_type_func (BluetoothClient* self,
                                      GDBusObjectManagerClient* manager,
                                      const gchar* object_path,
                                      const gchar* interface_name)
{
	GType result;
#line 72 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 72 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (manager != NULL, 0UL);
#line 72 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (object_path != NULL, 0UL);
#line 73 "../src/panel/applets/status/BluetoothClient.vala"
	if (interface_name == NULL) {
#line 73 "../src/panel/applets/status/BluetoothClient.vala"
		result = g_dbus_object_proxy_get_type ();
#line 73 "../src/panel/applets/status/BluetoothClient.vala"
		return result;
#line 332 "BluetoothClient.c"
	}
#line 75 "../src/panel/applets/status/BluetoothClient.vala"
	if (g_strcmp0 (interface_name, BLUEZ_ADAPTER_INTERFACE) == 0) {
#line 75 "../src/panel/applets/status/BluetoothClient.vala"
		result = adapter1_proxy_get_type ();
#line 75 "../src/panel/applets/status/BluetoothClient.vala"
		return result;
#line 340 "BluetoothClient.c"
	}
#line 77 "../src/panel/applets/status/BluetoothClient.vala"
	if (g_strcmp0 (interface_name, BLUEZ_DEVICE_INTERFACE) == 0) {
#line 77 "../src/panel/applets/status/BluetoothClient.vala"
		result = device1_proxy_get_type ();
#line 77 "../src/panel/applets/status/BluetoothClient.vala"
		return result;
#line 348 "BluetoothClient.c"
	}
#line 79 "../src/panel/applets/status/BluetoothClient.vala"
	result = g_dbus_proxy_get_type ();
#line 79 "../src/panel/applets/status/BluetoothClient.vala"
	return result;
#line 354 "BluetoothClient.c"
}

static void
bluetooth_client_create_upower_client_data_free (gpointer _data)
{
	BluetoothClientCreateUpowerClientData* _data_;
	_data_ = _data;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_slice_free (BluetoothClientCreateUpowerClientData, _data_);
#line 366 "BluetoothClient.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	return self ? g_object_ref (self) : NULL;
#line 374 "BluetoothClient.c"
}

static void
bluetooth_client_create_upower_client (BluetoothClient* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	BluetoothClientCreateUpowerClientData* _data_;
	BluetoothClient* _tmp0_;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_data_ = g_slice_new0 (BluetoothClientCreateUpowerClientData);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_client_create_upower_client_data_free);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_data_->self = _tmp0_;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_create_upower_client_co (_data_);
#line 398 "BluetoothClient.c"
}

static void
bluetooth_client_create_upower_client_finish (BluetoothClient* self,
                                              GAsyncResult* _res_)
{
	BluetoothClientCreateUpowerClientData* _data_;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 408 "BluetoothClient.c"
}

/**
 * Create and setup our UPower client.
 */
static void
bluetooth_client_create_upower_client_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	BluetoothClientCreateUpowerClientData* _data_;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
	_data_ = _user_data_;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
	_data_->_source_object_ = source_object;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
	_data_->_res_ = _res_;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_create_upower_client_co (_data_);
#line 428 "BluetoothClient.c"
}

static void
_bluetooth_client_upower_device_added_cb_up__client_device_added (UpClient* _sender,
                                                                  UpDevice* device,
                                                                  gpointer self)
{
#line 90 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_upower_device_added_cb ((BluetoothClient*) self, device);
#line 438 "BluetoothClient.c"
}

static void
_bluetooth_client_upower_device_removed_cb_up__client_device_removed (UpClient* _sender,
                                                                      const gchar* object_path,
                                                                      gpointer self)
{
#line 91 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_upower_device_removed_cb ((BluetoothClient*) self, object_path);
#line 448 "BluetoothClient.c"
}

static gboolean
bluetooth_client_create_upower_client_co (BluetoothClientCreateUpowerClientData* _data_)
{
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
	switch (_data_->_state_) {
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
		case 0:
#line 458 "BluetoothClient.c"
		goto _state_0;
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
		case 1:
#line 462 "BluetoothClient.c"
		goto _state_1;
		default:
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
		g_assert_not_reached ();
#line 467 "BluetoothClient.c"
	}
	_state_0:
	{
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp1_ = _data_->self->priv->cancellable;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_state_ = 1;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		up_client_new_async (_data_->_tmp1_, bluetooth_client_create_upower_client_ready, _data_);
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		return FALSE;
#line 479 "BluetoothClient.c"
		_state_1:
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp2_ = up_client_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 487 "BluetoothClient.c"
			goto __catch0_g_error;
		}
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp3_ = _data_->_tmp0_;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp0_ = NULL;
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (_data_->self->priv->upower_client);
#line 87 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->self->priv->upower_client = _data_->_tmp3_;
#line 90 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp4_ = _data_->self->priv->upower_client;
#line 90 "../src/panel/applets/status/BluetoothClient.vala"
		g_signal_connect_object (_data_->_tmp4_, "device-added", (GCallback) _bluetooth_client_upower_device_added_cb_up__client_device_added, _data_->self, 0);
#line 91 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp5_ = _data_->self->priv->upower_client;
#line 91 "../src/panel/applets/status/BluetoothClient.vala"
		g_signal_connect_object (_data_->_tmp5_, "device-removed", (GCallback) _bluetooth_client_upower_device_removed_cb_up__client_device_removed, _data_->self, 0);
#line 93 "../src/panel/applets/status/BluetoothClient.vala"
		bluetooth_client_coldplug_client (_data_->self);
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 510 "BluetoothClient.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->e = _data_->_inner_error0_;
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_inner_error0_ = NULL;
#line 95 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp6_ = _data_->e;
#line 95 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp7_ = _data_->_tmp6_->message;
#line 95 "../src/panel/applets/status/BluetoothClient.vala"
		g_critical ("BluetoothClient.vala:95: Error creating UPower client: %s", _data_->_tmp7_);
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
		_g_error_free0 (_data_->e);
#line 527 "BluetoothClient.c"
	}
	__finally0:
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
		g_object_unref (_data_->_async_result);
#line 86 "../src/panel/applets/status/BluetoothClient.vala"
		return FALSE;
#line 540 "BluetoothClient.c"
	}
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
	if (_data_->_state_ != 0) {
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 550 "BluetoothClient.c"
		}
	}
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
	g_object_unref (_data_->_async_result);
#line 85 "../src/panel/applets/status/BluetoothClient.vala"
	return FALSE;
#line 557 "BluetoothClient.c"
}

static void
bluetooth_client_create_object_manager_data_free (gpointer _data)
{
	BluetoothClientCreateObjectManagerData* _data_;
	_data_ = _data;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_slice_free (BluetoothClientCreateObjectManagerData, _data_);
#line 569 "BluetoothClient.c"
}

static void
bluetooth_client_create_object_manager (BluetoothClient* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	BluetoothClientCreateObjectManagerData* _data_;
	BluetoothClient* _tmp0_;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_data_ = g_slice_new0 (BluetoothClientCreateObjectManagerData);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_client_create_object_manager_data_free);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_data_->self = _tmp0_;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_create_object_manager_co (_data_);
#line 593 "BluetoothClient.c"
}

static void
bluetooth_client_create_object_manager_finish (BluetoothClient* self,
                                               GAsyncResult* _res_)
{
	BluetoothClientCreateObjectManagerData* _data_;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 603 "BluetoothClient.c"
}

/**
 * Create and setup our Bluez DBus object manager client.
 */
static GType
_bluetooth_client_get_proxy_type_func_gd_bus_proxy_type_func (GDBusObjectManagerClient* manager,
                                                              const gchar* object_path,
                                                              const gchar* interface_name,
                                                              gpointer self)
{
	GType result;
	result = bluetooth_client_get_proxy_type_func ((BluetoothClient*) self, manager, object_path, interface_name);
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
	return result;
#line 619 "BluetoothClient.c"
}

static void
bluetooth_client_create_object_manager_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	BluetoothClientCreateObjectManagerData* _data_;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
	_data_ = _user_data_;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
	_data_->_source_object_ = source_object;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
	_data_->_res_ = _res_;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_create_object_manager_co (_data_);
#line 636 "BluetoothClient.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	return _data4_;
#line 646 "BluetoothClient.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 656 "BluetoothClient.c"
		BluetoothClient* self;
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		self = _data4_->self;
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (_data4_->object);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (self);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		g_slice_free (Block4Data, _data4_);
#line 666 "BluetoothClient.c"
	}
}

static void
__lambda5_ (Block4Data* _data4_,
            GDBusInterface* iface)
{
	BluetoothClient* self;
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	self = _data4_->self;
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (iface != NULL);
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_on_interface_added (self, _data4_->object, iface);
#line 681 "BluetoothClient.c"
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	__lambda5_ (self, (GDBusInterface*) data);
#line 690 "BluetoothClient.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 698 "BluetoothClient.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 706 "BluetoothClient.c"
}

static void
___lambda4_ (BluetoothClient* self,
             GDBusObject* object)
{
	Block4Data* _data4_;
	GDBusObject* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (object != NULL);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	_data4_->_ref_count_ = 1;
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	_data4_->self = g_object_ref (self);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (_data4_->object);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	_data4_->object = _tmp0_;
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = g_dbus_object_get_interfaces (_data4_->object);
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp2_ = _tmp1_;
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	g_list_foreach (_tmp2_, ___lambda5__gfunc, _data4_);
#line 115 "../src/panel/applets/status/BluetoothClient.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	block4_data_unref (_data4_);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	_data4_ = NULL;
#line 743 "BluetoothClient.c"
}

static void
____lambda4__gfunc (gconstpointer data,
                    gpointer self)
{
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
	___lambda4_ ((BluetoothClient*) self, (GDBusObject*) data);
#line 752 "BluetoothClient.c"
}

static void
_bluetooth_client_on_interface_added_g_dbus_object_manager_interface_added (GDBusObjectManager* _sender,
                                                                            GDBusObject* object,
                                                                            GDBusInterface* interface_,
                                                                            gpointer self)
{
#line 119 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_on_interface_added ((BluetoothClient*) self, object, interface_);
#line 763 "BluetoothClient.c"
}

static void
_bluetooth_client_on_interface_removed_g_dbus_object_manager_interface_removed (GDBusObjectManager* _sender,
                                                                                GDBusObject* object,
                                                                                GDBusInterface* interface_,
                                                                                gpointer self)
{
#line 120 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_on_interface_removed ((BluetoothClient*) self, object, interface_);
#line 774 "BluetoothClient.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	return _data5_;
#line 784 "BluetoothClient.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 794 "BluetoothClient.c"
		BluetoothClient* self;
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
		self = _data5_->self;
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (_data5_->object);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (self);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
		g_slice_free (Block5Data, _data5_);
#line 804 "BluetoothClient.c"
	}
}

static void
__lambda8_ (Block5Data* _data5_,
            GDBusInterface* iface)
{
	BluetoothClient* self;
#line 123 "../src/panel/applets/status/BluetoothClient.vala"
	self = _data5_->self;
#line 123 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (iface != NULL);
#line 123 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_on_interface_added (self, _data5_->object, iface);
#line 819 "BluetoothClient.c"
}

static void
___lambda8__gfunc (gconstpointer data,
                   gpointer self)
{
#line 123 "../src/panel/applets/status/BluetoothClient.vala"
	__lambda8_ (self, (GDBusInterface*) data);
#line 828 "BluetoothClient.c"
}

static void
___lambda7_ (BluetoothClient* self,
             GDBusObject* object)
{
	Block5Data* _data5_;
	GDBusObject* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (object != NULL);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	_data5_->_ref_count_ = 1;
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	_data5_->self = g_object_ref (self);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (_data5_->object);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	_data5_->object = _tmp0_;
#line 123 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = g_dbus_object_get_interfaces (_data5_->object);
#line 123 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp2_ = _tmp1_;
#line 123 "../src/panel/applets/status/BluetoothClient.vala"
	g_list_foreach (_tmp2_, ___lambda8__gfunc, _data5_);
#line 123 "../src/panel/applets/status/BluetoothClient.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	block5_data_unref (_data5_);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	_data5_ = NULL;
#line 865 "BluetoothClient.c"
}

static void
____lambda7__g_dbus_object_manager_object_added (GDBusObjectManager* _sender,
                                                 GDBusObject* object,
                                                 gpointer self)
{
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
	___lambda7_ ((BluetoothClient*) self, object);
#line 875 "BluetoothClient.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	return _data6_;
#line 885 "BluetoothClient.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 895 "BluetoothClient.c"
		BluetoothClient* self;
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
		self = _data6_->self;
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (_data6_->object);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (self);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
		g_slice_free (Block6Data, _data6_);
#line 905 "BluetoothClient.c"
	}
}

static void
__lambda10_ (Block6Data* _data6_,
             GDBusInterface* iface)
{
	BluetoothClient* self;
#line 126 "../src/panel/applets/status/BluetoothClient.vala"
	self = _data6_->self;
#line 126 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (iface != NULL);
#line 126 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_on_interface_removed (self, _data6_->object, iface);
#line 920 "BluetoothClient.c"
}

static void
___lambda10__gfunc (gconstpointer data,
                    gpointer self)
{
#line 126 "../src/panel/applets/status/BluetoothClient.vala"
	__lambda10_ (self, (GDBusInterface*) data);
#line 929 "BluetoothClient.c"
}

static void
___lambda9_ (BluetoothClient* self,
             GDBusObject* object)
{
	Block6Data* _data6_;
	GDBusObject* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (object != NULL);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	_data6_->_ref_count_ = 1;
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	_data6_->self = g_object_ref (self);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = _g_object_ref0 (object);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (_data6_->object);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	_data6_->object = _tmp0_;
#line 126 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = g_dbus_object_get_interfaces (_data6_->object);
#line 126 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp2_ = _tmp1_;
#line 126 "../src/panel/applets/status/BluetoothClient.vala"
	g_list_foreach (_tmp2_, ___lambda10__gfunc, _data6_);
#line 126 "../src/panel/applets/status/BluetoothClient.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	block6_data_unref (_data6_);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	_data6_ = NULL;
#line 966 "BluetoothClient.c"
}

static void
____lambda9__g_dbus_object_manager_object_removed (GDBusObjectManager* _sender,
                                                   GDBusObject* object,
                                                   gpointer self)
{
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
	___lambda9_ ((BluetoothClient*) self, object);
#line 976 "BluetoothClient.c"
}

static gboolean
bluetooth_client_create_object_manager_co (BluetoothClientCreateObjectManagerData* _data_)
{
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
	switch (_data_->_state_) {
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
		case 0:
#line 986 "BluetoothClient.c"
		goto _state_0;
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
		case 1:
#line 990 "BluetoothClient.c"
		goto _state_1;
		default:
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
		g_assert_not_reached ();
#line 995 "BluetoothClient.c"
	}
	_state_0:
	{
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp1_ = _data_->self->priv->cancellable;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_state_ = 1;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		g_dbus_object_manager_client_new_for_bus (G_BUS_TYPE_SYSTEM, G_DBUS_OBJECT_MANAGER_CLIENT_FLAGS_NONE, BLUEZ_DBUS_NAME, BLUEZ_MANAGER_PATH, _bluetooth_client_get_proxy_type_func_gd_bus_proxy_type_func, g_object_ref (_data_->self), g_object_unref, _data_->_tmp1_, bluetooth_client_create_object_manager_ready, _data_);
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		return FALSE;
#line 1007 "BluetoothClient.c"
		_state_1:
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp2_ = g_dbus_object_manager_client_new_for_bus_finish (_data_->_res_, &_data_->_inner_error0_);
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1015 "BluetoothClient.c"
			goto __catch0_g_error;
		}
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp3_ = _data_->_tmp0_;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp0_ = NULL;
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (_data_->self->priv->object_manager);
#line 104 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->self->priv->object_manager = _data_->_tmp3_;
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp4_ = _data_->self->priv->object_manager;
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp5_ = g_dbus_object_manager_get_objects ((GDBusObjectManager*) _data_->_tmp4_);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		g_list_foreach (_data_->_tmp6_, ____lambda4__gfunc, _data_->self);
#line 114 "../src/panel/applets/status/BluetoothClient.vala"
		(_data_->_tmp6_ == NULL) ? NULL : (_data_->_tmp6_ = (_g_list_free__g_object_unref0_ (_data_->_tmp6_), NULL));
#line 119 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp7_ = _data_->self->priv->object_manager;
#line 119 "../src/panel/applets/status/BluetoothClient.vala"
		g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp7_, "interface-added", (GCallback) _bluetooth_client_on_interface_added_g_dbus_object_manager_interface_added, _data_->self, 0);
#line 120 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp8_ = _data_->self->priv->object_manager;
#line 120 "../src/panel/applets/status/BluetoothClient.vala"
		g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp8_, "interface-removed", (GCallback) _bluetooth_client_on_interface_removed_g_dbus_object_manager_interface_removed, _data_->self, 0);
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp9_ = _data_->self->priv->object_manager;
#line 122 "../src/panel/applets/status/BluetoothClient.vala"
		g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp9_, "object-added", (GCallback) ____lambda7__g_dbus_object_manager_object_added, _data_->self, 0);
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp10_ = _data_->self->priv->object_manager;
#line 125 "../src/panel/applets/status/BluetoothClient.vala"
		g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp10_, "object-removed", (GCallback) ____lambda9__g_dbus_object_manager_object_removed, _data_->self, 0);
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 1054 "BluetoothClient.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->e = _data_->_inner_error0_;
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_inner_error0_ = NULL;
#line 129 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp11_ = _data_->e;
#line 129 "../src/panel/applets/status/BluetoothClient.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 129 "../src/panel/applets/status/BluetoothClient.vala"
		g_critical ("BluetoothClient.vala:129: Error getting DBus Object Manager: %s", _data_->_tmp12_);
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
		_g_error_free0 (_data_->e);
#line 1071 "BluetoothClient.c"
	}
	__finally0:
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
		g_object_unref (_data_->_async_result);
#line 103 "../src/panel/applets/status/BluetoothClient.vala"
		return FALSE;
#line 1084 "BluetoothClient.c"
	}
#line 132 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_set_retrieve_finished (_data_->self, TRUE);
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
	if (_data_->_state_ != 0) {
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1096 "BluetoothClient.c"
		}
	}
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
	g_object_unref (_data_->_async_result);
#line 102 "../src/panel/applets/status/BluetoothClient.vala"
	return FALSE;
#line 1103 "BluetoothClient.c"
}

static void
___lambda11_ (BluetoothClient* self,
              GVariant* changed,
              gchar** invalid)
{
	GVariant* variant = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 145 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (changed != NULL);
#line 146 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = g_variant_type_new ("b");
#line 146 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = _tmp0_;
#line 146 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp2_ = g_variant_lookup_value (changed, "BluetoothAirplaneMode", _tmp1_);
#line 146 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp3_ = _tmp2_;
#line 146 "../src/panel/applets/status/BluetoothClient.vala"
	_g_variant_type_free0 (_tmp1_);
#line 146 "../src/panel/applets/status/BluetoothClient.vala"
	variant = _tmp3_;
#line 147 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp4_ = variant;
#line 147 "../src/panel/applets/status/BluetoothClient.vala"
	if (_tmp4_ == NULL) {
#line 147 "../src/panel/applets/status/BluetoothClient.vala"
		_g_variant_unref0 (variant);
#line 147 "../src/panel/applets/status/BluetoothClient.vala"
		return;
#line 1139 "BluetoothClient.c"
	}
#line 148 "../src/panel/applets/status/BluetoothClient.vala"
	g_signal_emit (self, bluetooth_client_signals[BLUETOOTH_CLIENT_AIRPLANE_MODE_CHANGED_SIGNAL], 0);
#line 145 "../src/panel/applets/status/BluetoothClient.vala"
	_g_variant_unref0 (variant);
#line 1145 "BluetoothClient.c"
}

static void
____lambda11__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                 GVariant* changed_properties,
                                                 gchar** invalidated_properties,
                                                 gpointer self)
{
#line 145 "../src/panel/applets/status/BluetoothClient.vala"
	___lambda11_ ((BluetoothClient*) self, changed_properties, invalidated_properties);
#line 1156 "BluetoothClient.c"
}

static void
bluetooth_client_create_rfkill_proxy (BluetoothClient* self)
{
	GError* _inner_error0_ = NULL;
#line 135 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 1165 "BluetoothClient.c"
	{
		Rfkill* _tmp0_ = NULL;
		GCancellable* _tmp1_;
		Rfkill* _tmp2_;
		Rfkill* _tmp3_;
		Rfkill* _tmp4_;
#line 137 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp1_ = self->priv->cancellable;
#line 137 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp2_ = (Rfkill*) g_initable_new (TYPE_RFKILL_PROXY, _tmp1_, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", RFKILL_DBUS_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", RFKILL_DBUS_PATH, "g-interface-name", "org.gnome.SettingsDaemon.Rfkill", NULL);
#line 137 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp0_ = (Rfkill*) _tmp2_;
#line 137 "../src/panel/applets/status/BluetoothClient.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1180 "BluetoothClient.c"
			goto __catch0_g_error;
		}
#line 137 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp3_ = _tmp0_;
#line 137 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp0_ = NULL;
#line 137 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (self->priv->rfkill);
#line 137 "../src/panel/applets/status/BluetoothClient.vala"
		self->priv->rfkill = _tmp3_;
#line 145 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp4_ = self->priv->rfkill;
#line 145 "../src/panel/applets/status/BluetoothClient.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) ____lambda11__g_dbus_proxy_g_properties_changed, self, 0);
#line 136 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (_tmp0_);
#line 1197 "BluetoothClient.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 136 "../src/panel/applets/status/BluetoothClient.vala"
		e = _inner_error0_;
#line 136 "../src/panel/applets/status/BluetoothClient.vala"
		_inner_error0_ = NULL;
#line 151 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp5_ = e;
#line 151 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp6_ = _tmp5_->message;
#line 151 "../src/panel/applets/status/BluetoothClient.vala"
		g_critical ("BluetoothClient.vala:151: Error getting RFKill proxy: %s", _tmp6_);
#line 136 "../src/panel/applets/status/BluetoothClient.vala"
		_g_error_free0 (e);
#line 1217 "BluetoothClient.c"
	}
	__finally0:
#line 136 "../src/panel/applets/status/BluetoothClient.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 136 "../src/panel/applets/status/BluetoothClient.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 136 "../src/panel/applets/status/BluetoothClient.vala"
		g_clear_error (&_inner_error0_);
#line 136 "../src/panel/applets/status/BluetoothClient.vala"
		return;
#line 1228 "BluetoothClient.c"
	}
}

/**
 * Handles the addition of a DBus object interface.
 */
static void
bluetooth_client_on_interface_added (BluetoothClient* self,
                                     GDBusObject* object,
                                     GDBusInterface* iface)
{
#line 158 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (object != NULL);
#line 158 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (iface != NULL);
#line 159 "../src/panel/applets/status/BluetoothClient.vala"
	if (IS_ADAPTER1 (iface)) {
#line 160 "../src/panel/applets/status/BluetoothClient.vala"
		bluetooth_client_set_has_adapter (self, TRUE);
#line 1250 "BluetoothClient.c"
	} else {
#line 161 "../src/panel/applets/status/BluetoothClient.vala"
		if (IS_DEVICE1 (iface)) {
#line 1254 "BluetoothClient.c"
			Device1* device = NULL;
			Device1* _tmp0_;
#line 162 "../src/panel/applets/status/BluetoothClient.vala"
			device = IS_DEVICE1 (iface) ? ((Device1*) iface) : NULL;
#line 163 "../src/panel/applets/status/BluetoothClient.vala"
			_tmp0_ = device;
#line 163 "../src/panel/applets/status/BluetoothClient.vala"
			g_signal_emit (self, bluetooth_client_signals[BLUETOOTH_CLIENT_DEVICE_ADDED_SIGNAL], 0, _tmp0_);
#line 1263 "BluetoothClient.c"
		}
	}
}

/**
 * Handles the removal of a DBus object interface.
 */
static void
bluetooth_client_on_interface_removed (BluetoothClient* self,
                                       GDBusObject* object,
                                       GDBusInterface* iface)
{
#line 170 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (object != NULL);
#line 170 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (iface != NULL);
#line 171 "../src/panel/applets/status/BluetoothClient.vala"
	if (IS_ADAPTER1 (iface)) {
#line 1284 "BluetoothClient.c"
		GList* _tmp0_;
		GList* _tmp1_;
#line 174 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp0_ = bluetooth_client_get_adapters (self);
#line 174 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp1_ = _tmp0_;
#line 174 "../src/panel/applets/status/BluetoothClient.vala"
		bluetooth_client_set_has_adapter (self, g_list_length (_tmp1_) > ((guint) 0));
#line 174 "../src/panel/applets/status/BluetoothClient.vala"
		(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 1295 "BluetoothClient.c"
	} else {
#line 175 "../src/panel/applets/status/BluetoothClient.vala"
		if (IS_DEVICE1 (iface)) {
#line 176 "../src/panel/applets/status/BluetoothClient.vala"
			g_signal_emit (self, bluetooth_client_signals[BLUETOOTH_CLIENT_DEVICE_REMOVED_SIGNAL], 0, IS_DEVICE1 (iface) ? ((Device1*) iface) : NULL);
#line 1301 "BluetoothClient.c"
		}
	}
}

/**
 * Handle when a UPower device is being added.
 */
static void
bluetooth_client_upower_device_added_cb (BluetoothClient* self,
                                         UpDevice* up_device)
{
	gchar* serial = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
#line 183 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (up_device != NULL);
#line 184 "../src/panel/applets/status/BluetoothClient.vala"
	g_object_get (up_device, "serial", &_tmp0_, NULL);
#line 184 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = _tmp0_;
#line 184 "../src/panel/applets/status/BluetoothClient.vala"
	serial = _tmp1_;
#line 187 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp3_ = serial;
#line 187 "../src/panel/applets/status/BluetoothClient.vala"
	if (_tmp3_ == NULL) {
#line 187 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp2_ = TRUE;
#line 1338 "BluetoothClient.c"
	} else {
		const gchar* _tmp4_;
#line 187 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp4_ = serial;
#line 187 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp2_ = !bluetooth_client_is_valid_address (self, _tmp4_);
#line 1345 "BluetoothClient.c"
	}
#line 187 "../src/panel/applets/status/BluetoothClient.vala"
	if (_tmp2_) {
#line 187 "../src/panel/applets/status/BluetoothClient.vala"
		_g_free0 (serial);
#line 187 "../src/panel/applets/status/BluetoothClient.vala"
		return;
#line 1353 "BluetoothClient.c"
	}
#line 189 "../src/panel/applets/status/BluetoothClient.vala"
	g_object_get (up_device, "native-path", &_tmp5_, NULL);
#line 189 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp6_ = _tmp5_;
#line 189 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp7_ = _tmp6_;
#line 189 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp8_ = !g_str_has_prefix (_tmp7_, BLUETOOTH_ADDRESS_PREFIX);
#line 189 "../src/panel/applets/status/BluetoothClient.vala"
	_g_free0 (_tmp7_);
#line 189 "../src/panel/applets/status/BluetoothClient.vala"
	if (_tmp8_) {
#line 189 "../src/panel/applets/status/BluetoothClient.vala"
		_g_free0 (serial);
#line 189 "../src/panel/applets/status/BluetoothClient.vala"
		return;
#line 1371 "BluetoothClient.c"
	}
#line 191 "../src/panel/applets/status/BluetoothClient.vala"
	g_signal_emit (self, bluetooth_client_signals[BLUETOOTH_CLIENT_UPOWER_DEVICE_ADDED_SIGNAL], 0, up_device);
#line 183 "../src/panel/applets/status/BluetoothClient.vala"
	_g_free0 (serial);
#line 1377 "BluetoothClient.c"
}

/**
 * Handles the removal of a UPower device.
 *
 * The Bluetooth device corresponding to the UPower device will have its
 * association removed, and its battery properties reset.
 */
static void
bluetooth_client_upower_device_removed_cb (BluetoothClient* self,
                                           const gchar* object_path)
{
#line 200 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (object_path != NULL);
#line 201 "../src/panel/applets/status/BluetoothClient.vala"
	if (!g_str_has_prefix (object_path, BLUETOOTH_ADDRESS_PREFIX)) {
#line 201 "../src/panel/applets/status/BluetoothClient.vala"
		return;
#line 1398 "BluetoothClient.c"
	}
#line 203 "../src/panel/applets/status/BluetoothClient.vala"
	g_signal_emit (self, bluetooth_client_signals[BLUETOOTH_CLIENT_UPOWER_DEVICE_REMOVED_SIGNAL], 0, object_path);
#line 1402 "BluetoothClient.c"
}

/**
 * Gets the result of the asynchronous UPower get_devices call and
 * calls our device_added function to try to map them to Bluetooth
 * devices.
 */
static void
bluetooth_client_upower_get_devices_cb (BluetoothClient* self,
                                        GObject* obj,
                                        GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 211 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 1418 "BluetoothClient.c"
	{
		GPtrArray* devices = NULL;
		UpClient* _tmp0_;
		GPtrArray* _tmp1_;
		GPtrArray* _tmp2_;
		GPtrArray* _tmp3_;
#line 213 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp0_ = self->priv->upower_client;
#line 213 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp1_ = up_client_get_devices_finish (_tmp0_, res, &_inner_error0_);
#line 213 "../src/panel/applets/status/BluetoothClient.vala"
		devices = _tmp1_;
#line 213 "../src/panel/applets/status/BluetoothClient.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1433 "BluetoothClient.c"
			goto __catch0_g_error;
		}
#line 215 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp2_ = devices;
#line 215 "../src/panel/applets/status/BluetoothClient.vala"
		if (_tmp2_ == NULL) {
#line 216 "../src/panel/applets/status/BluetoothClient.vala"
			g_warning ("BluetoothClient.vala:216: No UPower devices found");
#line 217 "../src/panel/applets/status/BluetoothClient.vala"
			_g_ptr_array_unref0 (devices);
#line 217 "../src/panel/applets/status/BluetoothClient.vala"
			return;
#line 1446 "BluetoothClient.c"
		}
#line 221 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp3_ = devices;
#line 1450 "BluetoothClient.c"
		{
			GPtrArray* device_collection = NULL;
			guint device_index = 0U;
#line 221 "../src/panel/applets/status/BluetoothClient.vala"
			device_collection = _tmp3_;
#line 221 "../src/panel/applets/status/BluetoothClient.vala"
			for (device_index = 0; device_index < device_collection->len; device_index = device_index + 1) {
#line 1458 "BluetoothClient.c"
				UpDevice* _tmp4_;
				UpDevice* device = NULL;
#line 221 "../src/panel/applets/status/BluetoothClient.vala"
				_tmp4_ = _g_object_ref0 ((UpDevice*) g_ptr_array_index (device_collection, device_index));
#line 221 "../src/panel/applets/status/BluetoothClient.vala"
				device = _tmp4_;
#line 1465 "BluetoothClient.c"
				{
					UpDevice* _tmp5_;
#line 222 "../src/panel/applets/status/BluetoothClient.vala"
					_tmp5_ = device;
#line 222 "../src/panel/applets/status/BluetoothClient.vala"
					bluetooth_client_upower_device_added_cb (self, _tmp5_);
#line 221 "../src/panel/applets/status/BluetoothClient.vala"
					_g_object_unref0 (device);
#line 1474 "BluetoothClient.c"
				}
			}
		}
#line 212 "../src/panel/applets/status/BluetoothClient.vala"
		_g_ptr_array_unref0 (devices);
#line 1480 "BluetoothClient.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 212 "../src/panel/applets/status/BluetoothClient.vala"
		e = _inner_error0_;
#line 212 "../src/panel/applets/status/BluetoothClient.vala"
		_inner_error0_ = NULL;
#line 225 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp6_ = e;
#line 225 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp7_ = _tmp6_->message;
#line 225 "../src/panel/applets/status/BluetoothClient.vala"
		g_warning ("BluetoothClient.vala:225: Error getting UPower devices: %s", _tmp7_);
#line 212 "../src/panel/applets/status/BluetoothClient.vala"
		_g_error_free0 (e);
#line 1500 "BluetoothClient.c"
	}
	__finally0:
#line 212 "../src/panel/applets/status/BluetoothClient.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../src/panel/applets/status/BluetoothClient.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 212 "../src/panel/applets/status/BluetoothClient.vala"
		g_clear_error (&_inner_error0_);
#line 212 "../src/panel/applets/status/BluetoothClient.vala"
		return;
#line 1511 "BluetoothClient.c"
	}
}

/**
 * Gets all UPower devices for the current Upower client, and tries to associate
 * each UPower device with the corresponding Bluetooth device.
 */
static void
_bluetooth_client_upower_get_devices_cb_gasync_ready_callback (GObject* source_object,
                                                               GAsyncResult* res,
                                                               gpointer self)
{
#line 239 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_upower_get_devices_cb ((BluetoothClient*) self, source_object, res);
#line 239 "../src/panel/applets/status/BluetoothClient.vala"
	g_object_unref (self);
#line 1528 "BluetoothClient.c"
}

static void
bluetooth_client_coldplug_client (BluetoothClient* self)
{
	UpClient* _tmp0_;
	UpClient* _tmp1_;
	GCancellable* _tmp2_;
#line 233 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = self->priv->upower_client;
#line 234 "../src/panel/applets/status/BluetoothClient.vala"
	if (_tmp0_ == NULL) {
#line 235 "../src/panel/applets/status/BluetoothClient.vala"
		return;
#line 1545 "BluetoothClient.c"
	}
#line 239 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = self->priv->upower_client;
#line 239 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp2_ = self->priv->cancellable;
#line 239 "../src/panel/applets/status/BluetoothClient.vala"
	up_client_get_devices_async (_tmp1_, _tmp2_, _bluetooth_client_upower_get_devices_cb_gasync_ready_callback, g_object_ref (self));
#line 1553 "BluetoothClient.c"
}

/**
 * Check if a Bluetooth address is valid.
 */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 1573 "BluetoothClient.c"
}

static gboolean
bluetooth_client_is_valid_address (BluetoothClient* self,
                                   const gchar* address)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean result;
#line 245 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 245 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (address != NULL, FALSE);
#line 246 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = strlen (address);
#line 246 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = _tmp0_;
#line 246 "../src/panel/applets/status/BluetoothClient.vala"
	if (_tmp1_ != 17) {
#line 247 "../src/panel/applets/status/BluetoothClient.vala"
		result = FALSE;
#line 247 "../src/panel/applets/status/BluetoothClient.vala"
		return result;
#line 1597 "BluetoothClient.c"
	}
	{
		gint i = 0;
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
		i = 0;
#line 1603 "BluetoothClient.c"
		{
			gboolean _tmp2_ = FALSE;
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
			_tmp2_ = TRUE;
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
			while (TRUE) {
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
				if (!_tmp2_) {
#line 1612 "BluetoothClient.c"
					gint _tmp3_;
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
					_tmp3_ = i;
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
					i = _tmp3_ + 1;
#line 1618 "BluetoothClient.c"
				}
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
				_tmp2_ = FALSE;
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
				if (!(i < 17)) {
#line 250 "../src/panel/applets/status/BluetoothClient.vala"
					break;
#line 1626 "BluetoothClient.c"
				}
#line 251 "../src/panel/applets/status/BluetoothClient.vala"
				if (((i + 1) % 3) == 0) {
#line 252 "../src/panel/applets/status/BluetoothClient.vala"
					if (string_get (address, (glong) i) != ':') {
#line 253 "../src/panel/applets/status/BluetoothClient.vala"
						result = FALSE;
#line 253 "../src/panel/applets/status/BluetoothClient.vala"
						return result;
#line 1636 "BluetoothClient.c"
					}
#line 255 "../src/panel/applets/status/BluetoothClient.vala"
					continue;
#line 1640 "BluetoothClient.c"
				}
#line 258 "../src/panel/applets/status/BluetoothClient.vala"
				if (!g_ascii_isxdigit (string_get (address, (glong) i))) {
#line 259 "../src/panel/applets/status/BluetoothClient.vala"
					result = FALSE;
#line 259 "../src/panel/applets/status/BluetoothClient.vala"
					return result;
#line 1648 "BluetoothClient.c"
				}
			}
		}
	}
#line 263 "../src/panel/applets/status/BluetoothClient.vala"
	result = TRUE;
#line 263 "../src/panel/applets/status/BluetoothClient.vala"
	return result;
#line 1657 "BluetoothClient.c"
}

/**
 * Get all Bluetooth adapters from our Bluez object manager.
 */
static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
	return _data7_;
#line 1670 "BluetoothClient.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1680 "BluetoothClient.c"
		BluetoothClient* self;
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
		self = _data7_->self;
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
		(_data7_->adapters == NULL) ? NULL : (_data7_->adapters = (_g_list_free__g_object_unref0_ (_data7_->adapters), NULL));
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (self);
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
		g_slice_free (Block7Data, _data7_);
#line 1690 "BluetoothClient.c"
	}
}

static void
__lambda6_ (Block7Data* _data7_,
            GDBusObject* object)
{
	BluetoothClient* self;
	GDBusInterface* iface = NULL;
	GDBusInterface* _tmp0_;
	GDBusInterface* _tmp1_;
	GDBusInterface* _tmp2_;
	Adapter1* _tmp3_;
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	self = _data7_->self;
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (object != NULL);
#line 273 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = g_dbus_object_get_interface (object, BLUEZ_ADAPTER_INTERFACE);
#line 273 "../src/panel/applets/status/BluetoothClient.vala"
	iface = _tmp0_;
#line 274 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = iface;
#line 274 "../src/panel/applets/status/BluetoothClient.vala"
	if (_tmp1_ == NULL) {
#line 274 "../src/panel/applets/status/BluetoothClient.vala"
		_g_object_unref0 (iface);
#line 274 "../src/panel/applets/status/BluetoothClient.vala"
		return;
#line 1720 "BluetoothClient.c"
	}
#line 275 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp2_ = iface;
#line 275 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp3_ = _g_object_ref0 (IS_ADAPTER1 (_tmp2_) ? ((Adapter1*) _tmp2_) : NULL);
#line 275 "../src/panel/applets/status/BluetoothClient.vala"
	_data7_->adapters = g_list_append (_data7_->adapters, _tmp3_);
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (iface);
#line 1730 "BluetoothClient.c"
}

static void
___lambda6__gfunc (gconstpointer data,
                   gpointer self)
{
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	__lambda6_ (self, (GDBusObject*) data);
#line 1739 "BluetoothClient.c"
}

static GList*
bluetooth_client_get_adapters (BluetoothClient* self)
{
	Block7Data* _data7_;
	GDBusObjectManagerClient* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* result;
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
	_data7_->_ref_count_ = 1;
#line 269 "../src/panel/applets/status/BluetoothClient.vala"
	_data7_->self = g_object_ref (self);
#line 270 "../src/panel/applets/status/BluetoothClient.vala"
	_data7_->adapters = NULL;
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = self->priv->object_manager;
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = g_dbus_object_manager_get_objects ((GDBusObjectManager*) _tmp0_);
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp2_ = _tmp1_;
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	g_list_foreach (_tmp2_, ___lambda6__gfunc, _data7_);
#line 272 "../src/panel/applets/status/BluetoothClient.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 278 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp3_ = _data7_->adapters;
#line 278 "../src/panel/applets/status/BluetoothClient.vala"
	_data7_->adapters = NULL;
#line 278 "../src/panel/applets/status/BluetoothClient.vala"
	result = _tmp3_;
#line 278 "../src/panel/applets/status/BluetoothClient.vala"
	block7_data_unref (_data7_);
#line 278 "../src/panel/applets/status/BluetoothClient.vala"
	_data7_ = NULL;
#line 278 "../src/panel/applets/status/BluetoothClient.vala"
	return result;
#line 1783 "BluetoothClient.c"
}

/**
 * Get whether or not Bluetooth airplane mode is enabled.
 */
gboolean
bluetooth_client_airplane_mode_enabled (BluetoothClient* self)
{
	Rfkill* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 284 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 285 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = self->priv->rfkill;
#line 285 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp1_ = rfkill_get_bluetooth_airplane_mode (_tmp0_);
#line 285 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp2_ = _tmp1_;
#line 285 "../src/panel/applets/status/BluetoothClient.vala"
	result = _tmp2_;
#line 285 "../src/panel/applets/status/BluetoothClient.vala"
	return result;
#line 1808 "BluetoothClient.c"
}

/**
 * Set whether or not Bluetooth airplane mode is enabled.
 */
void
bluetooth_client_set_airplane_mode (BluetoothClient* self,
                                    gboolean enabled)
{
	Rfkill* _tmp0_;
#line 291 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = self->priv->rfkill;
#line 292 "../src/panel/applets/status/BluetoothClient.vala"
	rfkill_set_bluetooth_airplane_mode (_tmp0_, enabled);
#line 1825 "BluetoothClient.c"
}

BluetoothClient*
bluetooth_client_construct (GType object_type)
{
	BluetoothClient * self = NULL;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	self = (BluetoothClient*) g_object_new (object_type, NULL);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	return self;
#line 1836 "BluetoothClient.c"
}

BluetoothClient*
bluetooth_client_new (void)
{
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	return bluetooth_client_construct (TYPE_BLUETOOTH_CLIENT);
#line 1844 "BluetoothClient.c"
}

gboolean
bluetooth_client_get_has_adapter (BluetoothClient* self)
{
	gboolean result;
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
	result = self->priv->_has_adapter;
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
	return result;
#line 1857 "BluetoothClient.c"
}

static void
bluetooth_client_set_has_adapter (BluetoothClient* self,
                                  gboolean value)
{
	gboolean old_value;
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
	old_value = bluetooth_client_get_has_adapter (self);
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
	if (old_value != value) {
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
		self->priv->_has_adapter = value;
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_client_properties[BLUETOOTH_CLIENT_HAS_ADAPTER_PROPERTY]);
#line 1875 "BluetoothClient.c"
	}
}

gboolean
bluetooth_client_get_retrieve_finished (BluetoothClient* self)
{
	gboolean result;
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
	result = self->priv->_retrieve_finished;
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
	return result;
#line 1889 "BluetoothClient.c"
}

static void
bluetooth_client_set_retrieve_finished (BluetoothClient* self,
                                        gboolean value)
{
	gboolean old_value;
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
	old_value = bluetooth_client_get_retrieve_finished (self);
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
	if (old_value != value) {
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
		self->priv->_retrieve_finished = value;
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
		g_object_notify_by_pspec ((GObject *) self, bluetooth_client_properties[BLUETOOTH_CLIENT_RETRIEVE_FINISHED_PROPERTY]);
#line 1907 "BluetoothClient.c"
	}
}

static GObject *
bluetooth_client_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothClient * self;
	GCancellable* _tmp0_;
#line 47 "../src/panel/applets/status/BluetoothClient.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_client_parent_class);
#line 47 "../src/panel/applets/status/BluetoothClient.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "../src/panel/applets/status/BluetoothClient.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLUETOOTH_CLIENT, BluetoothClient);
#line 48 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = g_cancellable_new ();
#line 48 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 48 "../src/panel/applets/status/BluetoothClient.vala"
	self->priv->cancellable = _tmp0_;
#line 51 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_create_rfkill_proxy (self);
#line 54 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_create_upower_client (self, NULL, NULL);
#line 57 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_create_object_manager (self, NULL, NULL);
#line 47 "../src/panel/applets/status/BluetoothClient.vala"
	return obj;
#line 1940 "BluetoothClient.c"
}

static void
bluetooth_client_class_init (BluetoothClientClass * klass,
                             gpointer klass_data)
{
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_type_class_adjust_private_offset (klass, &BluetoothClient_private_offset);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_client_get_property;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_client_set_property;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_client_constructor;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_client_finalize;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_CLIENT_HAS_ADAPTER_PROPERTY, bluetooth_client_properties[BLUETOOTH_CLIENT_HAS_ADAPTER_PROPERTY] = g_param_spec_boolean ("has-adapter", "has-adapter", "has-adapter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_CLIENT_RETRIEVE_FINISHED_PROPERTY, bluetooth_client_properties[BLUETOOTH_CLIENT_RETRIEVE_FINISHED_PROPERTY] = g_param_spec_boolean ("retrieve-finished", "retrieve-finished", "retrieve-finished", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1963 "BluetoothClient.c"
	/** Signal emitted when a Bluetooth device has been added. */
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_signals[BLUETOOTH_CLIENT_DEVICE_ADDED_SIGNAL] = g_signal_new ("device-added", TYPE_BLUETOOTH_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DEVICE1);
#line 1967 "BluetoothClient.c"
	/** Signal emitted when a Bluetooth device has been removed. */
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_signals[BLUETOOTH_CLIENT_DEVICE_REMOVED_SIGNAL] = g_signal_new ("device-removed", TYPE_BLUETOOTH_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DEVICE1);
#line 1971 "BluetoothClient.c"
	/** Signal emitted when a UPower device for a Bluetooth device has been detected. */
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_signals[BLUETOOTH_CLIENT_UPOWER_DEVICE_ADDED_SIGNAL] = g_signal_new ("upower-device-added", TYPE_BLUETOOTH_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, up_device_get_type ());
#line 1975 "BluetoothClient.c"
	/** Signal emitted when a UPower device for a Bluetooth device has been removed. */
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_signals[BLUETOOTH_CLIENT_UPOWER_DEVICE_REMOVED_SIGNAL] = g_signal_new ("upower-device-removed", TYPE_BLUETOOTH_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 1979 "BluetoothClient.c"
	/** Signal emitted when airplane mode state has been changed. */
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	bluetooth_client_signals[BLUETOOTH_CLIENT_AIRPLANE_MODE_CHANGED_SIGNAL] = g_signal_new ("airplane-mode-changed", TYPE_BLUETOOTH_CLIENT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1983 "BluetoothClient.c"
}

static void
bluetooth_client_instance_init (BluetoothClient * self,
                                gpointer klass)
{
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	self->priv = bluetooth_client_get_instance_private (self);
#line 33 "../src/panel/applets/status/BluetoothClient.vala"
	self->priv->_has_adapter = FALSE;
#line 34 "../src/panel/applets/status/BluetoothClient.vala"
	self->priv->_retrieve_finished = FALSE;
#line 1996 "BluetoothClient.c"
}

static void
bluetooth_client_finalize (GObject * obj)
{
	BluetoothClient * self;
	GCancellable* _tmp0_;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BLUETOOTH_CLIENT, BluetoothClient);
#line 61 "../src/panel/applets/status/BluetoothClient.vala"
	_tmp0_ = self->priv->cancellable;
#line 61 "../src/panel/applets/status/BluetoothClient.vala"
	if (_tmp0_ != NULL) {
#line 2010 "BluetoothClient.c"
		GCancellable* _tmp1_;
#line 62 "../src/panel/applets/status/BluetoothClient.vala"
		_tmp1_ = self->priv->cancellable;
#line 62 "../src/panel/applets/status/BluetoothClient.vala"
		g_cancellable_cancel (_tmp1_);
#line 2016 "BluetoothClient.c"
	}
#line 27 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 29 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (self->priv->object_manager);
#line 30 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (self->priv->upower_client);
#line 31 "../src/panel/applets/status/BluetoothClient.vala"
	_g_object_unref0 (self->priv->rfkill);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	G_OBJECT_CLASS (bluetooth_client_parent_class)->finalize (obj);
#line 2028 "BluetoothClient.c"
}

GType
bluetooth_client_get_type (void)
{
	return bluetooth_client_type_id;
}

GType
bluetooth_client_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothClient), 0, (GInstanceInitFunc) bluetooth_client_instance_init, NULL };
	bluetooth_client_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "BluetoothClient", &g_define_type_info, 0);
	BluetoothClient_private_offset = sizeof (BluetoothClientPrivate);
	return bluetooth_client_type_id;
}

static void
_vala_bluetooth_client_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	BluetoothClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BLUETOOTH_CLIENT, BluetoothClient);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	switch (property_id) {
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		case BLUETOOTH_CLIENT_HAS_ADAPTER_PROPERTY:
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		g_value_set_boolean (value, bluetooth_client_get_has_adapter (self));
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		break;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		case BLUETOOTH_CLIENT_RETRIEVE_FINISHED_PROPERTY:
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		g_value_set_boolean (value, bluetooth_client_get_retrieve_finished (self));
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		break;
#line 2068 "BluetoothClient.c"
		default:
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		break;
#line 2074 "BluetoothClient.c"
	}
}

static void
_vala_bluetooth_client_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	BluetoothClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BLUETOOTH_CLIENT, BluetoothClient);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
	switch (property_id) {
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		case BLUETOOTH_CLIENT_HAS_ADAPTER_PROPERTY:
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		bluetooth_client_set_has_adapter (self, g_value_get_boolean (value));
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		break;
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		case BLUETOOTH_CLIENT_RETRIEVE_FINISHED_PROPERTY:
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		bluetooth_client_set_retrieve_finished (self, g_value_get_boolean (value));
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		break;
#line 2100 "BluetoothClient.c"
		default:
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/panel/applets/status/BluetoothClient.vala"
		break;
#line 2106 "BluetoothClient.c"
	}
}

